/*

Copyright (C) 2002 J.D. Cole

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Octave; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*
  $Header: /home/jd/hpo/cvs-root/code/dld-projects/mpi/mpi_comm_size.cc,v 1.3 2002/12/11 08:23:44 jd Exp $
*/

#include <octave_mpi.h>

#include <mpi.h>
#include <octave/oct.h>

DEFUN_DLD(mpi_comm_size, ar, , "MPI_Comm_size")
{
  if(!octave_mpi_verify_session())
    {
      error("mpi_comm_size: mpi_init has not been called or"
	    " mpi_finalize has already been called");

      return octave_value(false);
    }

  int psize;
  
  if(MPI_SUCCESS== MPI_Comm_size(MPI_COMM_WORLD, &psize))
    {
      return octave_value((double) psize);
    }

  return octave_value((double)-1);
}
